summaryrefslogtreecommitdiff
path: root/tests
diff options
context:
space:
mode:
authorPádraig Brady <P@draigBrady.com>2012-12-12 19:54:12 +0000
committerPádraig Brady <P@draigBrady.com>2012-12-17 21:08:16 +0000
commita05a326b0cd7c4146e60ea4d66440d4a28dfb41a (patch)
treed705c35e9a745b7b7d530126fcf66da48c40bfaa /tests
parent0f525b6f94abcf4db87eb5bd754f20a684cd8242 (diff)
downloadcoreutils-a05a326b0cd7c4146e60ea4d66440d4a28dfb41a.tar.xz
readlink: support multiple command line arguments
This allows efficient processing of multiple files, while also increasing compatibility with BSD's readlink(1). We also add the -z, --zero option to delimit output items with the NUL character which disambiguates output in the presence of '\n' characters. * src/readlink.c (usage): Add the --zero description, and also adjust the description of --no-newline accordingly. (main): Handle the -z option and iterate over multiple arguments. Also as in commit v8.15-24-g9d46b25 we use fputs() and putchar() rather than printf() for performance reasons. * doc/coreutils.texi (readlink invocation): Document the new --zero option, adjust the --no-newline description, and tweak the general info to indicate multiple files are supported. * tests/readlink/multi.sh: A new test for the new functionality. * tests/local.mk: Reference the new test. * man/readlink.x: Adjust the summary and also reference realpath. * NEWS: Mention the improvement. * THANKS.in: Suggested by Aaron Davies.
Diffstat (limited to 'tests')
-rw-r--r--tests/local.mk1
-rwxr-xr-xtests/readlink/multi.sh46
2 files changed, 47 insertions, 0 deletions
diff --git a/tests/local.mk b/tests/local.mk
index 5eeddd53b..efdd896bf 100644
--- a/tests/local.mk
+++ b/tests/local.mk
@@ -602,6 +602,7 @@ all_tests = \
tests/readlink/can-e.sh \
tests/readlink/can-f.sh \
tests/readlink/can-m.sh \
+ tests/readlink/multi.sh \
tests/readlink/rl-1.sh \
tests/rmdir/fail-perm.sh \
tests/rmdir/ignore.sh \
diff --git a/tests/readlink/multi.sh b/tests/readlink/multi.sh
new file mode 100755
index 000000000..877cce6b3
--- /dev/null
+++ b/tests/readlink/multi.sh
@@ -0,0 +1,46 @@
+#!/bin/sh
+# test multiple argument handling.
+
+# Copyright (C) 2012 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/tests/init.sh"; path_prepend_ ./src
+print_ver_ readlink
+
+touch regfile || framework_failure_
+ln -s regfile link1 || framework_failure_
+
+readlink link1 link1 || fail=1
+readlink link1 link2 && fail=1
+readlink link1 link2 link1 && fail=1
+readlink -m link1 link2 || fail=1
+
+printf '/1\0/1\0' > exp || framework_failure_
+readlink -m --zero /1 /1 > out || fail=1
+compare exp out || fail=1
+
+# The largely redundant --no-newline option is ignored with multiple args.
+# Note BSD's readlink suppresses all delimiters, even with multiple args,
+# but that functionality was not thought useful.
+readlink -n -m --zero /1 /1 > out || fail=1
+compare exp out || fail=1
+
+# Note the edge case that the last xargs run may not have a delimiter
+rm out || framework_failure_
+printf '/1\0/1\0/1' > exp || framework_failure_
+printf '/1 /1 /1' | xargs -n2 readlink -n -m --zero >> out || fail=1
+compare exp out || fail=1
+
+Exit $fail